diff --git a/qemu-img.c b/qemu-img.c
index 247987d..a889c84 100644
--- a/qemu-img.c
+++ b/qemu-img.c
@@ -594,6 +594,10 @@ static int img_check(int argc, char **argv)
             help();
             break;
         case 'f':
+            if (fmt) {
+                error_report("-f may only be specified once");
+                return 1;
+            }
             fmt = optarg;
             break;
         case 'r':
@@ -608,6 +612,10 @@ static int img_check(int argc, char **argv)
             }
             break;
         case OPTION_OUTPUT:
+            if (output) {
+                error_report("--output may only be specified once");
+                return 1;
+            }
             output = optarg;
             break;
         case 'q':
@@ -716,9 +724,17 @@ static int img_commit(int argc, char **argv)
             help();
             break;
         case 'f':
+            if (fmt) {
+                error_report("-f may only be specified once");
+                return 1;
+            }
             fmt = optarg;
             break;
         case 't':
+            if (cache) {
+                error_report("-t may only be specified once");
+                return 1;
+            }
             cache = optarg;
             break;
         case 'q':
@@ -949,9 +965,17 @@ static int img_compare(int argc, char **argv)
             help();
             break;
         case 'f':
+            if (fmt1) {
+                error_report("-f may only be specified once");
+                return 1;
+            }
             fmt1 = optarg;
             break;
         case 'F':
+            if (fmt2) {
+                error_report("-F may only be specified once");
+                return 1;
+            }
             fmt2 = optarg;
             break;
         case 'p':
@@ -1906,9 +1930,17 @@ static int img_info(int argc, char **argv)
             help();
             break;
         case 'f':
+            if (fmt) {
+                error_report("-f may only be specified once");
+                return 1;
+            }
             fmt = optarg;
             break;
         case OPTION_OUTPUT:
+            if (output) {
+                error_report("--output may only be specified once");
+                return 1;
+            }
             output = optarg;
             break;
         case OPTION_BACKING_CHAIN:
@@ -2074,9 +2106,17 @@ static int img_map(int argc, char **argv)
             help();
             break;
         case 'f':
+            if (fmt) {
+                error_report("-f may only be specified once");
+                return 1;
+            }
             fmt = optarg;
             break;
         case OPTION_OUTPUT:
+            if (output) {
+                error_report("--output may only be specified once");
+                return 1;
+            }
             output = optarg;
             break;
         }
@@ -2282,7 +2322,7 @@ static int img_rebase(int argc, char **argv)
 
     /* Parse commandline parameters */
     fmt = NULL;
-    cache = BDRV_DEFAULT_CACHE;
+    cache = NULL;
     out_baseimg = NULL;
     out_basefmt = NULL;
     for(;;) {
@@ -2296,12 +2336,24 @@ static int img_rebase(int argc, char **argv)
             help();
             return 0;
         case 'f':
+            if (fmt) {
+                error_report("-f may only be specified once");
+                return 1;
+            }
             fmt = optarg;
             break;
         case 'F':
+            if (out_basefmt) {
+                error_report("-F may only be specified once");
+                return 1;
+            }
             out_basefmt = optarg;
             break;
         case 'b':
+            if (out_baseimg) {
+                error_report("-b may only be specified once");
+                return 1;
+            }
             out_baseimg = optarg;
             break;
         case 'u':
@@ -2311,6 +2363,10 @@ static int img_rebase(int argc, char **argv)
             progress = 1;
             break;
         case 't':
+            if (cache) {
+                error_report("-t may only be specified once");
+                return 1;
+            }
             cache = optarg;
             break;
         case 'q':
@@ -2319,6 +2375,10 @@ static int img_rebase(int argc, char **argv)
         }
     }
 
+    if (!cache) {
+        cache = BDRV_DEFAULT_CACHE;
+    }
+
     if (quiet) {
         progress = 0;
     }
@@ -2603,6 +2663,10 @@ static int img_resize(int argc, char **argv)
             help();
             break;
         case 'f':
+            if (fmt) {
+                error_report("-f may only be specified once");
+                return 1;
+            }
             fmt = optarg;
             break;
         case 'q':